bash3boilerplate/README.md

167 lines
6.0 KiB
Markdown
Raw Normal View History

2016-02-25 09:28:22 +00:00
<!-- badges/ -->
2016-02-16 14:01:51 +00:00
[![Build Status](https://travis-ci.org/kvz/bash3boilerplate.svg?branch=master)](https://travis-ci.org/kvz/bash3boilerplate)
2016-02-25 09:28:22 +00:00
<!-- /badges -->
2016-03-02 18:19:48 +00:00
[This document is formatted with GitHub-Flavored Markdown. ]:#
[For better viewing, including hyperlinks, read it online at ]:#
[https://github.com/kvz/bash3boilerplate/blob/master/README.md]:#
* [Overview](#overview)
* [Goals](#goals)
* [Features](#features)
* [Installation](#installation)
* [Changelog](#changelog)
* [Best Practices](#best-practices)
* [Frequently Asked Questions](#frequently-asked-questions)
* [Authors](#authors)
* [Sponsoring](#sponsoring)
* [License](#license)
## Overview
2016-02-16 14:01:51 +00:00
2013-02-25 22:54:34 +00:00
When hacking up BASH scripts, I often find there are some
2016-02-15 14:52:05 +00:00
higher level things like logging, configuration, command-line argument
2013-02-25 22:54:34 +00:00
parsing that:
2013-02-25 22:39:31 +00:00
2016-02-15 14:52:05 +00:00
- I need every time
2013-02-25 22:54:34 +00:00
- Take quite some effort to get right
- Keep you from your actual work
2013-02-25 22:39:31 +00:00
Here's an attempt to bundle those things in a generalized way so that
they are reusable as-is in most of my (and hopefully your, if not ping
me) programs.
2016-02-15 14:38:27 +00:00
## Goals
2016-03-02 18:19:48 +00:00
Delete-key-friendly. I propose using [`main.sh`] as a base and removing the
2016-02-16 21:41:01 +00:00
parts you don't need, rather than introducing a ton of packages, includes, compilers, etc.
2016-02-15 14:38:27 +00:00
Aiming for portability, I'm targeting Bash 3 (OSX still ships
with 3 for instance). If you're going to ask people to install
Bash 4 first, you might as well pick a more advanced language as a
dependency.
2016-02-17 08:35:25 +00:00
We're automatically testing bash3boilerplate and it's proven to work on:
- [Linux](https://travis-ci.org/kvz/bash3boilerplate/jobs/109804166#L91) `GNU bash, version 4.2.25(1)-release (x86_64-pc-linux-gnu)`
- [OSX](https://travis-ci.org/kvz/bash3boilerplate/jobs/109804167#L2453) `GNU bash, version 3.2.51(1)-release (x86_64-apple-darwin13)`
2016-02-15 14:38:27 +00:00
## Features
- Structure
2016-02-16 21:41:01 +00:00
- Safe defaults (break on error, pipefail, etc)
2016-02-15 14:38:27 +00:00
- Configuration by environment variables
- Configuration by command-line arguments (definitions parsed from help info,
so no duplication needed)
2016-02-16 20:04:22 +00:00
- Magic variables like `__file` and `__dir`
2016-02-15 14:38:27 +00:00
- Logging that supports colors and is compatible with [Syslog Severity levels](http://en.wikipedia.org/wiki/Syslog#Severity_levels)
2013-02-25 22:39:31 +00:00
2014-11-04 14:23:05 +00:00
## Installation
There are 3 ways you can install (parts of) b3bp:
2016-02-16 20:25:59 +00:00
1. Just get the main template: `wget https://raw.githubusercontent.com/kvz/bash3boilerplate/master/main.sh`
2. Clone the entire project: `git clone git@github.com:kvz/bash3boilerplate.git`
3. As of `v1.0.3`, b3bp can be installed as a `package.json` dependency via: `npm install --save bash3boilerplate`
2014-11-04 14:23:05 +00:00
2016-02-16 21:41:01 +00:00
Although *3* introduces a node.js dependency, this does allow for easy version pinning and distribution in environments that already have this prerequisite. But nothing prevents you from just using `curl` and keep your project or build system low on external dependencies.
2014-11-04 14:23:05 +00:00
2016-02-16 20:04:22 +00:00
## Changelog
2016-02-16 21:25:18 +00:00
### master (Unreleased)
2016-02-23 09:22:34 +00:00
- Fix Travis OSX testing (before, it would silently pass failures) (#10)
2016-02-23 08:47:11 +00:00
- Enable dashes in long, GNU style options, as well as numbers (thanks @zbeekman)
2016-02-17 12:42:26 +00:00
### v2.0.0 (2016-02-17)
2016-02-17 12:39:05 +00:00
- Add tests for `templater` and follow Library export best practices
- Add tests for `ini_val` and follow Library export best practices
- Add tests for `parse_url` and follow Library export best practices
- Add tests for `megamount` and follow Library export best practices
2016-02-17 12:39:05 +00:00
- Remove `bump` from `src` (BREAKING)
- Remove `semver` from `src` (BREAKING)
2016-02-17 08:54:52 +00:00
### v1.2.1 (2016-02-17)
2016-02-17 07:39:12 +00:00
- Add Travis CI automated testing for OSX (thanks @zbeekman)
2016-02-16 21:25:18 +00:00
### v1.2.0 (2016-02-16)
2016-02-16 20:04:22 +00:00
- Allow disabling colors via `NO_COLOR` environment variable
2016-02-16 21:41:01 +00:00
- Enable `errexit`, `nounset` and `pipefail` options at the top of the script already
2016-02-16 20:25:59 +00:00
- More refined colors (thanks @arathai)
2016-02-16 21:41:01 +00:00
- Add a changelog to the README
- Add `__os` magic var (limited to discovering OSX and defaulting to Linux for now)
- Add `__base` magic var (`main`, if the source script is `main.sh`)
2016-02-16 20:04:22 +00:00
- Enable long, GNU style options (thanks @zbeekman)
2016-02-17 07:39:12 +00:00
- Add Travis CI automated testing for Linux
2016-02-16 20:04:22 +00:00
### v1.1.0 (2015-06-29)
- Add `ALLOW_REMAINDERS` configuration to templater
2016-02-16 20:58:51 +00:00
- Fix typo: 'debugmdoe' to 'debugmode' (thanks @jokajak)
2016-02-16 20:04:22 +00:00
- Use `${BASH_SOURCE[0]}` for `__file` instead of `${0}`
### v1.0.3 (2014-11-02)
- Add `ini_val`, `megamount`, `parse_url`
- Add re-usable libraries in `./src`
2016-02-16 21:41:01 +00:00
- Use npm as an additional distribution channel
2016-02-16 20:04:22 +00:00
2014-11-04 14:23:05 +00:00
## Best practices
As of `v1.0.3`, b3bp adds some nice re-usable libraries in `./src`. Later on we'll be using snippets inside this directory to build custom packages. In order to make the snippets in `./src` more useful, we recommend these guidelines.
### Library exports
It's nice to have a bash package that can be used in the terminal and also be invoked as a command line function. To achieve this the exporting of your functionality *should* follow this pattern:
```bash
if [ "${BASH_SOURCE[0]}" != ${0} ]; then
export -f my_script
else
my_script "${@}"
exit $?
fi
```
This allows a user to `source` your script or invoke as a script.
```bash
# Running as a script
$ ./my_script.sh some args --blah
# Sourcing the script
$ source my_script.sh
$ my_script some more args --blah
```
(taken from the [bpkg](https://raw.githubusercontent.com/bpkg/bpkg/master/README.md) project)
### Miscellaneous
2014-11-04 14:23:05 +00:00
- In functions, use `local` before every variable declaration
- This project settles on two spaces for tabs
2014-11-04 14:23:05 +00:00
2016-03-02 18:19:48 +00:00
## Frequently Asked Questions
Please see the [FAQ.md](./FAQ.md) file.
2016-02-17 07:39:12 +00:00
## Authors
2016-03-02 18:19:48 +00:00
- [Kevin van Zonneveld](<http://kvz.io>)
- [Izaak Beekman](<https://izaakbeekman.com/>)
- [Alexander Rathai](mailto:<Alexander.Rathai@gmail.com>)
2016-02-17 07:39:12 +00:00
2016-02-15 14:38:27 +00:00
## Sponsoring
2016-02-15 11:04:32 +00:00
<!-- badges/ -->
2016-02-16 20:25:59 +00:00
[![Flattr donate button](http://img.shields.io/flattr/donate.png?color=green)](https://flattr.com/submit/auto?user_id=kvz&url=https://github.com/kvz/bash3boilerplate&title=bash3boilerplate&language=&tags=github&category=software "Sponsor the development of bash3boilerplate via Flattr")
2016-02-15 11:04:32 +00:00
<!-- /badges -->
2013-03-27 15:08:31 +00:00
## License
2013-03-27 16:56:19 +00:00
Copyright (c) 2013 Kevin van Zonneveld, [http://kvz.io](http://kvz.io)
2013-03-28 13:23:24 +00:00
Licensed under MIT: [http://kvz.io/licenses/LICENSE-MIT](http://kvz.io/licenses/LICENSE-MIT)
2016-03-02 18:19:48 +00:00
[main.sh]: ./main.sh